package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;
import Jama.*;
/**
 * FindAuthorities.java
 *
 *
 * Created: Sun Jan 19 13:24:48 2003
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class FindAuthorities {
    public FindAuthorities (){
	
    }
    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        FileWriter outputFileWriter;       

        r.load(args[0]);
        Adjacency adjacencyTable = r.getAdjacency();

	Iterator pageRanks = AuthorityMetrics.toVector(AuthorityMetrics.findPageRanks(adjacencyTable)).iterator();
	Iterator hubs = AuthorityMetrics.toVector(AuthorityMetrics.findHubs(adjacencyTable)).iterator();
	Iterator authorities = AuthorityMetrics.toVector(AuthorityMetrics.findAuthorities(adjacencyTable)).iterator();


        try{        
	    outputFileWriter = new FileWriter( "pageRank-eigen.txt", true);
	    while(pageRanks.hasNext())
		outputFileWriter.write(pageRanks.next().toString()+"\n");

	    outputFileWriter.close();

	    outputFileWriter = new FileWriter( "hubs-eigen.txt", true);
	    while(hubs.hasNext()) 
		outputFileWriter.write(hubs.next().toString()+"\n");
	    outputFileWriter.close();

	    outputFileWriter = new FileWriter( "authorities-eigen.txt", true);
	    while(authorities.hasNext()) 
		outputFileWriter.write(authorities.next().toString()+"\n");
	    outputFileWriter.close();
		
	} 

	catch( Exception e )
	    {
		e.printStackTrace();
	    }
    }
}// FindAuthorities
