package edu.ncsu.simulators.analysis;

import java.util.*;
import Jama.util.*;
import Jama.Matrix; 
import edu.ncsu.simulators.util.*;
import java.io.*;

/**
 * FindBipartites.java
 *
 *
 * Created: Fri Mar  7 13:18:19 2003
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class FindBipartites {
    public FindBipartites (){
	
    }

    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        FileWriter outputFileWriter;

        int bipartite = 0;
	int components = 0;

        r.load(args[0]);
                
        Adjacency adjacencyTable = r.getAdjacency();

	int[] color = new int[adjacencyTable.size()]; 
        int[] parent = new int[adjacencyTable.size()];
        int[] cc = new int[adjacencyTable.size()];
	

	bipartite = Bipartite.offBipartite(adjacencyTable);
	components = Search.numberOfComponents(color, parent, cc, adjacencyTable);

	//System.out.println("off bipartite " + Bipartite.offBipartite(adjacencyTable));
	//System.out.println("components " + Search.numberOfComponents(color, parent, cc, adjacencyTable));
        try {
		outputFileWriter = new FileWriter( "bipartite-component.txt", true);
		outputFileWriter.write(new Integer(bipartite).toString());
                outputFileWriter.write("\t");
                outputFileWriter.write(new Integer(components).toString());
                outputFileWriter.write("\n");
                outputFileWriter.close();

		
	} 

	catch( Exception e )
	{
		e.printStackTrace();
	}
    }
}// FindBipartites
