/*
 * FindDistribution.java
 *
 * Created on October 20, 2001, 5:49 PM
 */
package edu.ncsu.simulators.analysis;


import java.util.*;
import java.io.*;
/**
 *
 * @author  pirnal
 * @version 
 */

  /** This is the main file for the power-law experiments
   *  finds the indegree, outdegree and the aggregates
   *  and writes them in the in.txt, out.txt, in-out.txt, 
   */
public class FindDistribution  {

    /** Creates new RunAnalysis */
    public FindDistribution() {
    }

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        
        r.load(args[0]);
                
        Adjacency adjacencyTable = r.getAdjacency();
     
        Vector agents = r.getAgents();

        Vector edges = adjacencyTable.getEdges();
        FileWriter outputFileWriter;
             
        int numberofAgents = adjacencyTable.size();
        
	int[][] shortestPaths = new int[numberofAgents][numberofAgents];
        int[] d = new int[numberofAgents];
        int[] p = new int[numberofAgents];
        

       for (int i =0; i<numberofAgents; i++)
           System.out.println("Agent " + i+ " incoming: "+Metrics.numberOfIncomingNodes(adjacencyTable, i) + " outgoing: " + Metrics.numberOfOutgoingNodes(adjacencyTable, i));

       try 
	{
		outputFileWriter = new FileWriter( "in-out.txt", false);	     
	        for (int i =0; i<numberofAgents; i++){
		    outputFileWriter.write(new Double(Metrics.numberOfIncomingNodes
					   (adjacencyTable, i)).toString());
		    outputFileWriter.write("\t");
		    outputFileWriter.write(new Double(Metrics.numberOfOutgoingNodes
					   (adjacencyTable, i)).toString());
		    outputFileWriter.write("\n");
                }
		outputFileWriter.write("\n");
	        outputFileWriter.close();

		outputFileWriter = new FileWriter( "out.txt", false);	     
		Hashtable h = Metrics.outgoingNodes(adjacencyTable);
	        Enumeration e = h.keys();
		while (e.hasMoreElements()){
		    Integer i =(Integer)(e.nextElement());
		
		    outputFileWriter.write(((Integer)(h.get(i))).toString());
		    outputFileWriter.write("\t");
		    outputFileWriter.write(i.toString());
		    outputFileWriter.write("\n");
                }
	        outputFileWriter.close();

		outputFileWriter = new FileWriter( "in.txt", false);	     
		 h = Metrics.incomingNodes(adjacencyTable);
	         e = h.keys();
		while (e.hasMoreElements()){
		    Integer i =(Integer)(e.nextElement());
		    outputFileWriter.write(((Integer)(h.get(i))).toString());
		    outputFileWriter.write("\t");
		    outputFileWriter.write(i.toString());
		    outputFileWriter.write("\n");
                }
	        outputFileWriter.close();
	}	
	catch( Exception e )
	{
		e.printStackTrace();
	}
    }

}
