package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;
/**
 * FindPageRanks.java
 *
 *
 * Created: Thu Aug  8 18:59:01 2002
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class FindPageRanks {
    public FindPageRanks (){
	
    }
    
    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        
        //r.load(args[0]+"/NeighborSetChanges_2.STATE");
        r.load(args[0]);                
        Adjacency adjacencyTable = r.getAdjacency();
     
        Vector agents = r.getAgents();

        Vector edges = adjacencyTable.getEdges();
        FileWriter outputFileWriter;
             
        int numberofAgents = adjacencyTable.size();

	//int numberOfIterations = Integer.parseInt(args[1]);
	double difference = Double.parseDouble(args[1]);

	DoubleVector pageRanks = new DoubleVector();

	//Initialize pageRanks to 1
	for (int i=0; i<numberofAgents; i++) 
	    pageRanks.add(1.0);

	//Iterate until converges with difference 
	pageRanks = Metrics.iteratePageRanks(difference, adjacencyTable, pageRanks);

	try {
	    outputFileWriter = new FileWriter("pageRank.txt", false);	     
	    for (int j =0; j<numberofAgents; j++){
		  outputFileWriter.write((new Double(pageRanks.elementAt(j))).toString());
		  outputFileWriter.write("\n");
	    }
	    outputFileWriter.close();
	}


	catch( Exception e ) {
	    e.printStackTrace();
	}
    }


}// FindPageRanks
