package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;
/**
 * FindSociabilityRanks.java
 *
 *
 * Created: Tue Jan 21 23:20:06 2003
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class FindSociabilityRanks {
    public FindSociabilityRanks (){
	
    }
    

    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        
        r.load(args[0]);                
        Adjacency adjacencyTable = r.getAdjacency();
	adjacencyTable.fill();

	IntHashTable models = r.getModels();
     
        FileWriter outputFileWriter;
             
        int numberofAgents = adjacencyTable.size();

	//int numberOfIterations = Integer.parseInt(args[1]);
	double difference = Double.parseDouble(args[1]);
	//domain number
	int dimension = Integer.parseInt(args[2]);
	DoubleVector pageRanks = new DoubleVector();

	//Initialize pageRanks to 1
	for (int i=0; i<numberofAgents; i++) 
	    pageRanks.add(1.0);

	System.out.println("Start iterating");
	
	//Iterate until converges with difference 
	pageRanks = Metrics.iterateSociabilityRanks(difference, adjacencyTable, models, pageRanks, dimension);

	try {
	    outputFileWriter = new FileWriter(new String("sociabilityRank_"+dimension+".txt"), false);	     
	    for (int j =0; j<numberofAgents; j++){
		  outputFileWriter.write((new Double(pageRanks.elementAt(j))).toString());
		  outputFileWriter.write("\n");
	    }
	    outputFileWriter.close();
	}


	catch( Exception e ) {
	    e.printStackTrace();
	}
    }
}// FindSociabilityRanks
