package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;

/**
 * FindUtilities.java
 *
 *
 * Created: Fri Mar 14 00:23:51 2003
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class FindUtilities {
    public FindUtilities (){
	
    }

    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        
        r.load(args[0]);
                
        Adjacency adjacencyTable = r.getAdjacency();
        VectorTable interestTable =r.getInterestTable(); 
        VectorTable expertiseTable=r.getExpertiseTable();
        int numberofAgents = adjacencyTable.size();

        FileWriter outputFileWriter;
	double difference = Double.parseDouble(args[1]);

	DoubleVector utilities = 
	    Metrics.totalUtilities(adjacencyTable, interestTable, expertiseTable, difference);


	try {
	    outputFileWriter = new FileWriter(new String("utilities.txt"), false);	     
	    for (int j =0; j<numberofAgents; j++)
		  outputFileWriter.write((new Double(utilities.elementAt(j))).toString()+"\n");
	    outputFileWriter.close();
	}


	catch( Exception e ) {
	    e.printStackTrace();
	}
    }
    
}// FindUtilities
