/*
 * IntHashTable.java
 *
 * Created on October 10, 2001, 3:18 PM
 */

package edu.ncsu.simulators.analysis;

import java.util.*;
import edu.ncsu.simulators.agent.*;
/**
 *
 * @author  pirnal
 * @version 
 */
public class IntHashTable {
  /** Hashtable where the indices are integers 
   *
   */
    private Hashtable h = new Hashtable();
    public IntHashTable() {
    }
    
    /**
     * Describe <code>geth</code> method here.
     *
     * @return a <code>Hashtable</code> value
     */
    public Hashtable geth(){
        return h;
    }
    


    /**
     * Describe <code>containsKey</code> method here.
     *
     * @param i an <code>int</code> value
     * @return a <code>boolean</code> value
     */
    public boolean containsKey(int i){
        return h.containsKey(new Integer(i));
    }
    /**
     * Describe <code>put</code> method here.
     *
     * @param i an <code>int</code> value
     * @param k an <code>Object</code> value
     * @return an <code>Object</code> value
     */
    public Object put(int i, Object k){
        return h.put(new Integer(i), k);
    }

    public Object at(int i) {
        return h.get(new Integer(i));
    }

    /**
     * Describe <code>elements</code> method here.
     *
     * @return an <code>Enumeration</code> value
     */
    public Enumeration elements() {

	return h.elements();
    }
    /**
     * Adds the double elements 
     *
     * @return a <code>double</code> value
     */
    public double totalWeights() {
	
	return totalWeights(0);
	
    }

    /**
     * Adds those elements greater than theta
     *
     * @param theta a <code>double</code> value
     * @return a <code>double</code> value
     */
    public double totalWeights(double theta) {
	
	double sum = 0.0;
	double current = 0.0;

	Enumeration e = this.elements();
	while (e.hasMoreElements()) {
	    current = ((Double)e.nextElement()).doubleValue();
	    if (current>theta) 
		sum += current;
	    
	} // end of while ()
	return sum;
	
    }


    /**
     * Describe <code>size</code> method here.
     *
     * @return an <code>int</code> value
     */
    public int size() {
        return h.size();
    }
    /**
     * Describe <code>keySet</code> method here.
     *
     * @return a <code>Set</code> value
     */
    public Set keySet(){
        return h.keySet();
    }

    /**
     * Describe <code>keys</code> method here.
     *
     * @return an <code>Enumeration</code> value
     */
    public Enumeration keys(){
	return h.keys();
  }
     


    /**
     *  Returns pairs of edges
     *
     * @return a <code>Vector</code> value
     */
    public Vector getEdges() {

	Enumeration v= h.keys();
        Enumeration e= h.elements();
        Vector edges = new Vector();
        Integer[] list;
        Integer i;
        TreeSet t= new TreeSet();
        
	while (v.hasMoreElements()){
            
            i = (Integer)v.nextElement();
            
               t = (TreeSet) e.nextElement(); 
               list = (Integer[])t.toArray(new Integer[0]);
               for (int j=0; j<t.size(); j++){
                   edges.add(i);
                   edges.add(list[j]);
               }    
        }
        return edges;
    }

    /**
     * When generating the edges, all add edges for the other
     * direction, so that the graph can be used as undirected.
     *
     * @return a <code>Vector</code> value 
     */
    public Vector getUndirectedEdges() {

	Enumeration v= h.keys();
        Enumeration e= h.elements();
        Vector edges = new Vector();
        Integer[] list;
        Integer i;
        TreeSet t= new TreeSet();
        
	while (v.hasMoreElements()){
            
	    i = (Integer)v.nextElement();
	    t = (TreeSet) e.nextElement(); 

            list = (Integer[])t.toArray(new Integer[0]);
	    for (int j=0; j<t.size(); j++){
		edges.add(i);
                edges.add(list[j]);
		if (!((TreeSet)(h.get(list[j]))).contains(i)) {
		    edges.add(list[j]);
		    edges.add(i);
		} // end of if ()
            }    
        }
        return edges;
    }
    
    
    public void write(Iterator i){
        while(i.hasNext())
            System.out.println(i.next());
    }


    /**
     * Create a table for n keys all with value d
     *
     * @param n an <code>int</code> value
     * @param d a <code>double</code> value
     * @return an <code>IntHashTable</code> value
     */
    public  static IntHashTable createFullTable(int n, double d) {

	IntHashTable table = new IntHashTable();

	for (int i=0; i<n; i++) {
	    table.put (i, new Double(d));
	    
	} // end of for ()
	
	return table;
    }

    public void fill(double d) {

	for (int i=0; i<this.size(); i++) {
	    if (((IntHashTable)at(i)).size()==0) {
		put(i, createFullTable(this.size(), d));
	    } // end of if ()
	    
	    
	} // end of for ()
	

    }

}
