/*
 * RunAnalysis.java
 *
 * Created on October 20, 2001, 5:49 PM
 */

package edu.ncsu.simulators.analysis;


import java.util.*;
import java.io.*;
/**
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version 
 */
public class RunAccuracy {
  /** Similar to RunAnalysis. but here we only look at accuracy how
   *  many messages have been sent, how many of them resulted in
   *  correct answers, etc.
   */

    /** Creates new RunAnalysis */
    public RunAccuracy() {
    }

    /**
    * @param args the command line arguments
    * arg[0] is the file name (neighborstate...), arg[1] is the dir name
    */
    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        
        r.load(args[0]);
	Adjacency adjacencyTable = r.getAdjacency();
        
        FileWriter outputFileWriter;

	Vector accuracy = new Vector();
        int numberofAgents = adjacencyTable.size();

        
	 accuracy = Metrics.accuracy(numberofAgents, args[1]);
       
       try{   
                outputFileWriter = new FileWriter( "accuracy.txt", true);
		System.out.println("correct answers " + ((Double)accuracy.get(0)).doubleValue());
       System.out.println("total answers " + ((Double)accuracy.get(1)).doubleValue());

                outputFileWriter.write(((Double)accuracy.get(0)).toString());
                outputFileWriter.write("\t");
                outputFileWriter.write(((Double)accuracy.get(1)).toString());
                outputFileWriter.write("\n");
                outputFileWriter.close();
	}
       	
	catch( Exception e )
	{
		e.printStackTrace();
	}
    }

}
