package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;
/**
 * RunClustering.java
 *
 *
 * Created: Fri Nov 29 15:28:02 2002
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class RunClustering {

    public RunClustering () {
	
    }
    
    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        
        r.load(args[0]);
	Adjacency adjacencyTable = r.getAdjacency();

        VectorTable interestTable =r.getInterestTable(); 
        VectorTable expertiseTable=r.getExpertiseTable();
	
        Vector agents = r.getAgents();

        
        FileWriter outputFileWriter;

        double interestSimilarity = 0.0; 
        double expertiseSimilarity = 0.0; 
	double plainClustering = 0.0;
	double reciprocity = 0.0;

        int numberofAgents = adjacencyTable.size();
	//Find interest similarity clustering
	interestSimilarity = Metrics.interestSimilarity(interestTable, 
							adjacencyTable, agents);

	expertiseSimilarity= Metrics.interestSimilarity(expertiseTable, 
							adjacencyTable, agents);

	plainClustering = Metrics.plainClustering(adjacencyTable, agents);

	reciprocity = Metrics.reciprocity(numberofAgents, adjacencyTable);
       	//System.out.println("reciprocity " + reciprocity);
	try{   
	    outputFileWriter = new FileWriter("clustering.txt", true);
	    outputFileWriter.write(new Double(interestSimilarity).toString());
            outputFileWriter.write("\t");
	    outputFileWriter.write(new Double(expertiseSimilarity).toString());
            outputFileWriter.write("\t");
            outputFileWriter.write(new Double(plainClustering).toString());
            outputFileWriter.write("\t");
            outputFileWriter.write(new Double(reciprocity).toString());
            outputFileWriter.write("\n");
            outputFileWriter.close();
	}
       	
	catch( Exception e )
	    {
		e.printStackTrace();
	    }
    }

}// RunClustering
