/*
 * RunCommunities.java
 *
 * Created late February
 */

package edu.ncsu.simulators.analysis;


import java.util.*;
import java.io.*;
/**
 *
 * @author  pirnal
 * @version 
 */
public class RunCommunities {
  /** Main class to call bipartite community search.
   *  
   *
   */

    /** Creates new RunCommunities */
    public RunCommunities() {
    }

    public static void main (String args[]) {
        GraphReader r = new GraphReader();
	HashSet cores = new HashSet();
	HashSet core = new HashSet();
 
        FileWriter outputFileWriter;       
        r.load(args[0]);
                
        Adjacency adjacencyTable = r.getAdjacency();

	cores = Bipartite.findAllBipartiteCores(adjacencyTable, 6 , 3);
	
	Iterator i = cores.iterator();

	int counter = 0;
	int j = 0;
	Vector hubs = new Vector();
	Vector authorities = new  Vector();



	/* Write all communities to the file */
        try{        
		while(i.hasNext()) {
		    core = (HashSet)i.next();
		    
		    hubs = AuthorityMetrics.toVector(AuthorityMetrics.findHubs(adjacencyTable.takePart(core)));
		    authorities = AuthorityMetrics.toVector(AuthorityMetrics.findAuthorities(adjacencyTable.takePart(core)));


		    outputFileWriter = new FileWriter( "k-communities6A_"+counter+".txt", true);

		    Iterator e = core.iterator();
		    while (e.hasNext()) {
			outputFileWriter.write(((Integer)e.next()).toString()+"\t");
			outputFileWriter.write(((Integer)hubs.elementAt(j)).toString()+"\t");
			outputFileWriter.write(((Integer)authorities.elementAt(j)).toString()+"\n");
			j++;
		    } // end of while ()
		    outputFileWriter.close();
		    counter++;
		}
	} 

	catch( Exception e )
	{
		e.printStackTrace();
	}
    }

}
