package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;

/**
 * RunLatticeAccuracy.java
 *
 *
 * Created: Fri Aug 23 15:52:14 2002
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class RunLatticeAccuracy {
    public RunLatticeAccuracy (){
	
    }

    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        
        r.load(args[0]);
	Adjacency adjacencyTable = r.getAdjacency();
        
        FileWriter outputFileWriter;

	Vector goodAnswers = new Vector();
	Vector existingAnswers = new Vector();
	Vector fromOthers = new Vector();
	Vector contactedPeers= new Vector();

        int numberofAgents = adjacencyTable.size();

	int iterations = (Integer.valueOf(args[2])).intValue(); 

	goodAnswers = Metrics.gotGoodAnswer(iterations,numberofAgents, args[1]);
        existingAnswers = Metrics.numberOfExistingProviders(iterations ,numberofAgents, args[1]);
	fromOthers = Metrics.gotFromOthers(iterations,numberofAgents, args[1]); 

	contactedPeers = Metrics.numberOfContactedAgents(iterations,numberofAgents, args[1]);
       
       try{   

                outputFileWriter = new FileWriter( "goodAnswers.txt", true);
		for (int  i=0; i<(numberofAgents*iterations); i++) {
		    outputFileWriter.write(((Double)goodAnswers.get(i)).toString());
		    outputFileWriter.write("\n");
		} // end of for ()
		outputFileWriter.close();

                outputFileWriter = new FileWriter( "othersAnswers.txt", true);
		for (int  i=0; i<(numberofAgents*iterations); i++) {
		    outputFileWriter.write(((Double)fromOthers.get(i)).toString());
		    outputFileWriter.write("\n");
		} // end of for ()
		outputFileWriter.close();

		outputFileWriter = new FileWriter( "existingAnswers.txt", true);
		for (int i=0; i<numberofAgents*iterations; i++) {
		    outputFileWriter.write(((Double)existingAnswers.get(i)).toString());
		    outputFileWriter.write("\n");
		} // end of for ()
		outputFileWriter.close();

   		outputFileWriter = new FileWriter( "contactedPeers.txt", true);
		for (int i=0; i<numberofAgents*iterations; i++) {
		    outputFileWriter.write(((Double)contactedPeers.get(i)).toString());
		    outputFileWriter.write("\n");
		} // end of for ()
		outputFileWriter.close();

	}
       	
	catch( Exception e )
	{
		e.printStackTrace();
	}
    }
}// RunLatticeAccuracy
