package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;
/**
 * RunShortPaths.java
 *
 *
 * Created: Fri Feb 21 12:32:42 2003
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class RunShortPaths {
    public RunShortPaths (){
	
    }
    
    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        
        r.load(args[0]);
                
        Adjacency adjacencyTable = r.getAdjacency();

        Vector agents = r.getAgents();

        FileWriter outputFileWriter;
        int numberofAgents = adjacencyTable.size();
	
	int[][] shortestPaths = new int[numberofAgents][numberofAgents];
        int[] d = new int[numberofAgents*2]; 
        int[] p = new int[numberofAgents*2];
	double avgPath = 0;
        
        for (int j=0; j<numberofAgents; j++){
	    ShortestPath.undirectedbelmannford(adjacencyTable, 
			((Integer)agents.get(j)).intValue(), d, p);
            for (int k=0; k<numberofAgents; k++)
	      shortestPaths[j][k] = d[k];
          
	    }

	//	avgPath = ShortestPath.averageLength(shortestPaths, numberofAgents);

	try {
	    outputFileWriter = new FileWriter( "average_shortest_path.txt", true);
	    for (int i=0; i<(numberofAgents-1); i++) {
		for (int j=i+1; j<numberofAgents; j++) {
		    //    if ((Metrics.numberOfIncomingNodes(adjacencyTable, j)!=0) || 
		    //	(Metrics.numberOfIncomingNodes(adjacencyTable, j)!=0)) {

			outputFileWriter.write(new Integer(i).toString()+ " " + new Integer(j).toString() + " " + new Integer(Math.min(shortestPaths[i][j], shortestPaths[j][i])).toString()+"\n");
			avgPath += Math.min(shortestPaths[i][j], shortestPaths[j][i]);
			//} // end of if ()
		
		} // end of for ()
	    outputFileWriter.write("\n");	    
	    } // end of for ()
	    outputFileWriter.write(new Double(2*avgPath/(numberofAgents*(numberofAgents-1))).toString()+"\n");
	    outputFileWriter.close();
	} 

	catch( Exception e )
	{
		e.printStackTrace();
	}
    }

}// RunShortPaths






