/*
 * ShortestPath.java
 *
 * Created on October 21, 2001, 1:42 PM
 */

package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;
/**
 *
 * @author  pirnal
 * @version 
 */

public class ShortestPath  {
/** Finds the shortest paths between a single source and multiple 
 *  destinations.  uses Bellman-ford algorithm.
 */

    /** Creates new ShortestPath */
    public ShortestPath() {
    }
    
     //CLR
  /** v is the vector of vertices, i is the source vertex, size
   *  is the number of vertices
   */
    public static void initializeSingleSource(Integer[] v, int i, int size, int[] d, int[] predecessor){
        int index = 0;
     
        for (int j=0; j<size; j++){
            
            index = ((Integer)v[j]).intValue();
            //1000 meaning infinity here. 
            d[index]=1000;
            predecessor[index]=-1;
        }
        d[i]=0;
        
    }
    
    public static void relax(int u, int v, int[] d, int[] predecessor){

        if (d[v]> (d[u]+ 1)){
	     d[v] =d[u] +1;
             predecessor[v]=u;
        }
    }
    
    public static void belmannford(Adjacency a, int s, int[] d, int[] predecessor){
        Vector v = a.getEdges();

        Integer[] list = (Integer[])(a.keySet()).toArray(new Integer[0]);
        initializeSingleSource(list, s, a.size(), d, predecessor);
        for (int j=0; j<(a.size()-1); j++)
            for (int k=0; k<(v.size()); k+=2){
                 relax(((Integer)v.get(k)).intValue(), ((Integer)v.get(k+1)).intValue(), d, predecessor);
            }    
      
    }

    public static void undirectedbelmannford(Adjacency a, int s, int[] d, int[] predecessor){
        Vector v = a.getUndirectedEdges();

        Integer[] list = (Integer[])(a.keySet()).toArray(new Integer[0]);
        initializeSingleSource(list, s, a.size(), d, predecessor);
        for (int j=0; j<(a.size()-1); j++)
            for (int k=0; k<(v.size()); k+=2){
                 relax(((Integer)v.get(k)).intValue(), ((Integer)v.get(k+1)).intValue(), d, predecessor);
            }    
      
    }

    /**
     * Treats the graph undirected and returns the average shortest
     * distance
     *
     * @param paths an <code>int[][]</code> value
     * @param agents an <code>int</code> value
     * @return a <code>double</code> value 
     */
    public static double averageLength(int[][] paths, int agents) {
	int shortPath = 0;

	for (int i=0; i<(agents-1); i++) {
	    for (int j=i+1; j<agents; j++) {
		shortPath += Math.min(paths[i][j], paths[j][i]);
		
	    } // end of for ()
	    
	} // end of for ()

	return (2*shortPath/(agents*(agents-1)));
    }
}
