/*
 * SubdueWriter.java
 *
 * Created late February
 */

package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;


public class SubdueWriter {
    /** Reads in a neighbor state file and generated adjacency,
     *  expertise table, etc.  
    */

    private Adjacency adjacency;
    int numberOfAgents = 0;
    FileWriter outputFileWriter;
    String fileName;
    /** Creates new SubdueWriter */
    public SubdueWriter(Adjacency a, String f) {
	adjacency = a;
	fileName = f;
    }

    public void write(){
	numberOfAgents = adjacency.size();
	TreeSet t = new TreeSet();
	Iterator setIterator;
	int neighbor = 0;
  
	try{
	    outputFileWriter = new FileWriter( fileName, true);
	    for (int i=0; i<numberOfAgents; i++){
		outputFileWriter.write("v " + (i+1) + " " + i + "\n");
	    }
	    for (int j=0; j<numberOfAgents; j++){
		t = adjacency.get(j);
		if (t !=null){
		    setIterator = t.iterator();
		    while (setIterator.hasNext()){
			neighbor = ((Integer)setIterator.next()).intValue();
			outputFileWriter.write("e " + (j+1) + " " + (neighbor+1) + " " + j +"->" +
					       neighbor + "\n"); 
		    }
		}
	    }
	    outputFileWriter.close();

	} 

        catch( Exception e )
	    {
		e.printStackTrace();
	    }
    }
}
