/*
 * Created by IntelliJ IDEA.
 * User: root
 * Date: Mar 19, 2002
 * Time: 6:06:59 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package edu.ncsu.simulators.concept;

import java.util.*;

import edu.ncsu.simulators.util.*;

public class Context {
    HashSet objects, attributes;

    public Context (HashSet objs, HashSet atts){
        objects = objs;
        attributes = atts;
    }

    public boolean addObject(FormalObject obj){
        return objects.add(obj);
    }

    public boolean addAttribute(FormalAttribute att) {
        return attributes.add(att);
    }

    public HashSet getObjectsPrime(HashSet objs){
        HashSet mainSet = null;

        if (objects.containsAll(objs)) {
            Iterator i = objs.iterator();
            HashSet newSet;
            mainSet = new HashSet();

            while (i.hasNext()) {
                FormalObject obj = (FormalObject) i.next();
                newSet = obj.getAttributes();
                mainSet = SetOperations.intersection(mainSet, newSet);
            }
        }

        return mainSet;
    }

    public HashSet getAttributesPrime(HashSet atts) {
        HashSet mainSet = null;

        if (attributes.containsAll(atts)) {
            Iterator i = atts.iterator();
            HashSet newSet;

            while (i.hasNext()) {
                FormalAttribute att = (FormalAttribute) i.next();
                newSet = att.getObjects();
                if (mainSet == null){
                    mainSet = newSet;
                } else {
                    //System.out.println("mainset = "+mainSet+"\nnewset = "+newSet);
                    mainSet = SetOperations.intersection(mainSet, newSet);
                    //System.out.println("After intersection, mainSet = "+mainSet);
                }
            }
        } else {
            System.out.println("Attributes in context : \n" + attributes);
            System.out.println("Context does not contain one or more attributes in the set" + atts);
        }

        return mainSet;
    }

    public HashSet getConcepts() {
    	HashSet concepts = new HashSet();
        HashSet conObjs = new HashSet();
        HashSet newSet,temp;

        conObjs.add(objects);

        Iterator i = attributes.iterator();
        while (i.hasNext()) {
            FormalAttribute att = (FormalAttribute) i.next();
            newSet = new HashSet();
            newSet = att.getObjects();

            Iterator it = conObjs.iterator();
            temp = new HashSet();
            while (it.hasNext()) {
                HashSet con = (HashSet) it.next();
                temp.add(SetOperations.intersection(con, newSet));
            }
            conObjs.addAll(temp);
        }
        
        Iterator ite = conObjs.iterator();
        while (ite.hasNext()){
        	concepts.add(new ObjectConcept((HashSet)ite.next()));
        }

        return concepts;
    }
    
    public ConceptLattice getConceptLattice(){
    	return new ConceptLattice(getConcepts());
    }

    public static void main(String[] args) {
        FormalAttribute a, b, c, d;
        FormalObject N1, N2, N3;
        HashSet objs, atts;
        Context con;

        objs = new HashSet();
        atts = new HashSet();

        a = new FormalAttribute("a");
        b = new FormalAttribute("b");
        c = new FormalAttribute("c");
        d = new FormalAttribute("d");
        atts.add(a);
        atts.add(b);
        atts.add(c);
        atts.add(d);

        N1 = new FormalObject("N1");
        N2 = new FormalObject("N2");
        N3 = new FormalObject("N3");
        objs.add(N1);
        objs.add(N2);
        objs.add(N3);

        N1.addAttribute(a);
        N1.addAttribute(b);
        N1.addAttribute(c);

        N2.addAttribute(a);
        N2.addAttribute(b);
        N2.addAttribute(c);
        N2.addAttribute(d);

        N3.addAttribute(b);
        N3.addAttribute(c);
        N3.addAttribute(d);

        con = new Context(objs, atts);
        HashSet test = new HashSet();
        test.add(c);test.add(b);
        HashSet ans = con.getAttributesPrime(test);

        System.out.println("\n\n*******ANSWER***************\n"+ans);
        System.out.println("\n\n*******concepts***************\n"+con.getConcepts());

    }
}
