
package edu.ncsu.simulators.evaluation.evaluators;

import edu.ncsu.simulators.concept.*;
import edu.ncsu.simulators.evaluation.*;
import edu.ncsu.simulators.evaluation.results.*;

import java.util.*;

public class ConceptWiseAgentEvaluator extends AgentEvaluator {
	
	ScoreTable table;
	AgentScorings trueScores;
	//constructors
	public ConceptWiseAgentEvaluator(ScoreTable table,AgentScorings trueScores){
		this.table = table;
		this.trueScores = trueScores;
	}
	
	public Evaluation evaluate(){
		Evaluation evaluation = null;
		Context context = getContext();
		
		ConceptLattice concepts = context.getConceptLattice();
		
		concepts.sort();
		Iterator ite = concepts.iterator();
		while (ite.hasNext()){
			Evaluation eval = evaluate((Concept)ite.next());
		}
		
		return evaluation;
	}
	
	private Context getContext(){
		HashSet atts, objs;
		
		atts = new HashSet();
		myAddAll(atts, table.getRatingAgents());
		
		objs = new HashSet();	
		myAddAll(objs, table.getServiceProviders());
		
		return new Context(atts,objs);
	}
	
	public Evaluation evaluate(Concept c){
		Score score;
		Enumeration sps = trueScores.getRatedServiceProviders();
		
		
		
		return null;
	}		
	
	private void myAddAll(Collection c, Iterator i){
		while (i.hasNext())
			c.add(i.next());
	}
}
