/*
 * Created by IntelliJ IDEA.
 * User: root
 * Date: Mar 26, 2002
 * Time: 1:51:18 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package edu.ncsu.simulators.evaluation.evaluators;

import edu.ncsu.simulators.agent.*;
import edu.ncsu.simulators.classification.HierarchicalCategory;
import edu.ncsu.simulators.evaluation.*;
import edu.ncsu.simulators.evaluation.results.*;
import edu.ncsu.simulators.service.*;
import java.util.*;

public class WeightedEvaluator extends ScoreEvaluator {
    RatingAgent myAgent;

    public WeightedEvaluator(Agent ag){
        try {
            this.myAgent = (RatingAgent) ag;
        } catch (Exception e) {
            System.out.println("Weighted Evaluator can only be used" +
                                " with a RatingAgent");
            System.exit(0);
        }
    }


    public Evaluation evaluate(ScoreTable table) {
        ServiceProviderEvaluation eval = new ServiceProviderEvaluation();

        Iterator sps = table.getServiceProviders();

        while (sps.hasNext()) {
            ServiceProvider sp = (ServiceProvider) sps.next();
            Iterator scores = table.getScoresForServiceProvider(sp);
            HierarchicalCategory cat = (HierarchicalCategory)sp.getCategory();
            float i, count;

            //count = 0;
            count = i = (float)0.0;

            while (scores.hasNext()) {
                Score score = (Score) scores.next(); 
                RatingAgentModel am = (RatingAgentModel)myAgent.agentModels.getModel(new Integer(score.getAgentID()));
                float j = ((FloatValue)(am.getRating(cat).getValue())).getValue();
                i = i + ((FloatValue)score.getValue()).getValue() * j;
                count += j;
            }

            i = i/count;
            //System.out.println(i);

            eval.setEvaluation(sp, new Score(myAgent.getID(), sp, new FloatValue(i)));
        }

        return eval;
    }
}
