package edu.ncsu.simulators.evaluation.results;

/**
 * This is the local reputation of an agent as modelled by 
 * the host agent. Each LocalReputation object can be thought
 * of as an entry(node) in the graphical representation of the 
 * RatingAgentModel
 */

import edu.ncsu.simulators.agent.AgentModel;
import edu.ncsu.simulators.classification.*;
import edu.ncsu.simulators.evaluation.results.*;
import edu.ncsu.simulators.evaluation.Value;

import java.util.*;

public class LocalReputation{

    Rating rating;
    Category cat;

    //constructors

	public LocalReputation(){
	}

    public LocalReputation(Rating v){
    	rating = v;
    }

	public LocalReputation(Category c){
		cat = c;
	}
	
	public LocalReputation(Rating r, Category c){
		rating = r;
		cat = c;
	}
	
	public void setRating(Value v){
		if (rating == null) {
			rating = new Rating(v);
		} else {
			rating.update(v);
		}
	}
	
	public void setRating(Rating r) {
		rating = r;
	}
	
	public Rating getRating(){
		return rating;
	}	

	public boolean setCategory(Category c){
		cat = c;
		return true;
	}
	
	public Category getCategory() {
		return cat;
	}

}
