package edu.ncsu.simulators.policies;

import edu.ncsu.simulators.Constants;
import edu.ncsu.simulators.policies.Heuristics;
import edu.ncsu.simulators.util.Statistics;
import edu.ncsu.simulators.agent.AgentModel;
import edu.ncsu.simulators.agent.AgentModels;
import edu.ncsu.simulators.vectors.*;

import edu.ncsu.simulators.agent.Neighbors;

import java.util.Iterator;
import java.util.Random;
import java.util.Vector;

/**
 * AnsweringPolicy_Interest.java
 *
 *
 * Created: Mon Dec  2 16:52:07 2002
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class AnsweringPolicy_Interest extends AnsweringPolicy_Standard implements AnsweringPolicy{
    public AnsweringPolicy_Interest (){
	
    }

    public Answer generateAnswer( AgentModel modelQuestioner, Query query, Expertise expertise, Interests interest, int myId, Neighbors neighbors) {

	Answer finalAnswer = null;

	if ( Heuristics.areSufficientlySimilar(interest, modelQuestioner.getInterests(), Constants.SIMILARITY_THRESHOLD_FOR_ANSWERING_QUESTIONER)) {

	    finalAnswer = generateAnswerIfExpert(modelQuestioner, query,  expertise);
	} // end of if
	
	return finalAnswer;
    }

    
}// AnsweringPolicy_Interest

