package edu.ncsu.simulators.policies;

import edu.ncsu.simulators.Constants;
import edu.ncsu.simulators.policies.Heuristics;
import edu.ncsu.simulators.util.Statistics;
import edu.ncsu.simulators.agent.AgentModel;
import edu.ncsu.simulators.agent.AgentModels;
import edu.ncsu.simulators.vectors.*;
import edu.ncsu.simulators.agent.Neighbors;

import java.util.Iterator;
import java.util.Random;
import java.util.Vector;

/**
 * The policy: Always answer. Make up the answer randomly.
 * 
 *
 * @author pirnal
*/
public class AnsweringPolicy_Random implements AnsweringPolicy
{
    // the random number generator used by this agent
    private Random random = null;	
	
	
    public AnsweringPolicy_Random()
    {
	random = Statistics.getRandomNumberGenerator();	
    }
	
    public Answer generateAnswer( AgentModel modelQuestioner, Query query, Expertise expertise, Interests interest, int myId, Neighbors neighbors)
    {

	Answer answer = new Answer();
	double expertiseComponent = 0;
	double answerComponent = 0;
	double percentage = 0;
	double sign = -1;
		
	answer = new Answer();
			
	Iterator iteratorExpertiseComponents = expertise.iterator();

	while( iteratorExpertiseComponents.hasNext() )
	    {
		percentage = random.nextDouble();

		if (Math.min( 0.5, random.nextDouble())==0.5)
		    sign = 1;

		expertiseComponent = ((Double)iteratorExpertiseComponents.next()).doubleValue();			
		answerComponent = expertiseComponent + (sign * percentage * expertiseComponent);


		answerComponent = Math.max( 0, answerComponent );
		answerComponent = Math.min( 1, answerComponent );

		answer.add( new Double(answerComponent) );
	    }


    return answer;	
}
	
//=======================================================================
}
