package edu.ncsu.simulators.policies;

import edu.ncsu.simulators.vectors.Query;
import edu.ncsu.simulators.vectors.Expertise;
import edu.ncsu.simulators.vectors.Interests;
import edu.ncsu.simulators.Constants;
import java.util.Random;
/**
 * Defines how the agent will generate queries
 * 
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version 1.0
 */

public interface QueryGenerationPolicy
{	

    /**
     * <code>generateQuery</code> generates a new query
     *
     * @param expertise an <code>Expertise</code> value
     * @param interests an <code>Interests</code> value
     * @return a <code>Query</code> value
     */
    public Query generateQuery(Expertise expertise, Interests interests, Random random );
}
