package edu.ncsu.simulators.policies;

import edu.ncsu.simulators.Constants;
import edu.ncsu.simulators.agent.AgentModel;
import edu.ncsu.simulators.agent.AgentModels;
import edu.ncsu.simulators.agent.Neighbors;
import edu.ncsu.simulators.policies.Heuristics;
import edu.ncsu.simulators.vectors.Query;

import java.util.Hashtable;
import java.util.Iterator;

/**
 * ReferringPolicy_Combined.java
 *
 *
 * Created: Sun Feb  9 14:11:48 2003
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class ReferringPolicy_Combined implements ReferringPolicy {
    public ReferringPolicy_Combined (){
	
    }

	public Iterator getNeighborsToReferTo( AgentModel modelQuestioner, Query query, Neighbors neighbors, AgentModels agentModels, int myId )
	{
		return getNeighborsWithSufficientSimilarity( query, neighbors, agentModels, Constants.SIMILARITY_THRESHOLD_FOR_REFERING_QUESTIONER_TO_NEIGHBOR );
	}	
	

       public Iterator getNeighborsWithSufficientSimilarity( Query query, Neighbors neighbors, AgentModels agentModels, double similarityThreshold )
	{	
		Hashtable hashKnowledgeableNeighbors = new Hashtable();
		Iterator iteratorNeighbors = neighbors.iterator();
		
		while( iteratorNeighbors.hasNext() )
		{
			Integer neighborID = (Integer)iteratorNeighbors.next();		
			AgentModel neighborModel = agentModels.getModel( neighborID );			

			double relevance = Math.max(Heuristics.calculateSimilarity(query, neighborModel.getExpertise()), Heuristics.calculateSociabilitySimilarity(query, neighborModel.getSociability()));

			if ( relevance> similarityThreshold ) 
			{
				hashKnowledgeableNeighbors.put( neighborID, neighborID );
			}
		}
		
		return hashKnowledgeableNeighbors.values().iterator();
	}	

    
}// ReferringPolicy_Combined
