//==========================================================================
//	This source code is part of the Agent Simulation Test Bed system which
//	was developed for simulating interaction among agents who are attempting 
//	to acquire information from each other and learn about each other. 
//
//	The system was created at North Carolina State Univeristy, 
//	Department of Computer Science between September and December 2001. 
//	It was implemented by Michael J. Suralik based on the specifications 
//	developed by Pinar Yolum and Bin Yu, who were conducting research under 
//   the guidance of Dr. Munindar Singh. 
//==========================================================================
package edu.ncsu.simulators.util;

import java.io.*;

/**
 * The FileManager bundles together inovocations on java.io objects in order
 * to provide some high level file management functionality.   
 * All methods in this utility class should be public.
 */
public final class FileManager
{	
	//========================================================================			
	
	private FileManager()
	{	
	}	
	
	//=======================================================================		
	/**
	 * Copies the specified source file to a file with name of the specified
	 * target file.
	 */
	public static void copy( String sourceFileName, String targetFileName )
	{
		try
		{
			FileReader reader = new FileReader( sourceFileName );
			FileWriter writer = new FileWriter( targetFileName );
			
			int c = 0;
			
			while ( (c = reader.read()) != -1 )
			{
				writer.write( c );
			}
			
			reader.close();
			writer.close();
		}
		catch ( Exception e )
		{
			e.printStackTrace();
		}
	}
	
	//========================================================================
}