//==========================================================================
//	This source code is part of the Agent Simulation Test Bed system which
//	was developed for simulating interaction among agents who are attempting 
//	to acquire information from each other and learn about each other. 
//
//	The system was created at North Carolina State Univeristy, 
//	Department of Computer Science between September and December 2001. 
//	It was implemented by Michael J. Suralik based on the specifications 
//	developed by Pinar Yolum and Bin Yu, who were conducting research under 
//      the guidance of Dr. Munindar Singh. 
//==========================================================================

package edu.ncsu.simulators.vectors;

import net.n3.nanoxml.IXMLElement;
/**
 * An Expertise SimulationVector represents the body of knowledge that an agent
 * possesses.
 */
public class DomainExpertise extends Expertise
{
	
    //========================================================================		
	
    public DomainExpertise()
    {
    }
	
    //========================================================================		
	
    public Expertise copy()
    {
	return (Expertise)copy( new DomainExpertise() );
    }
	
    //========================================================================		
    /**
     *
     */	
    public DomainExpertise( int dimensions )
    {
	setSize( dimensions );
    }	
	
    //========================================================================	
	
    public Expertise parse( IXMLElement xmlExpertise )
    {
	return (Expertise)parseFromXML( xmlExpertise, new DomainExpertise() );
    }	

    public void toTruncatedXML( IXMLElement xmlExpertise){ 
	super.toTruncatedXML(xmlExpertise);
    }
	
    //========================================================================		

    public int getSize(){
	return size();
    }
}
