//==========================================================================
//	This source code is part of the Agent Simulation Test Bed system which
//	was developed for simulating interaction among agents who are attempting 
//	to acquire information from each other and learn about each other. 
//
//	The system was created at North Carolina State Univeristy, 
//	Department of Computer Science between September and December 2001. 
//	It was implemented by Michael J. Suralik based on the specifications 
//	developed by Pinar Yolum and Bin Yu, who were conducting research under 
//   the guidance of Dr. Munindar Singh. 
//==========================================================================

package edu.ncsu.simulators.vectors;

import edu.ncsu.simulators.Constants;
import edu.ncsu.simulators.io.StateWriter;
import edu.ncsu.simulators.util.Statistics;

import net.n3.nanoxml.*;

import java.util.Enumeration;
import java.util.Random;
import java.util.Vector;

/**
 * An Interests SimulationVector represents a body of knowledge that an agent
 * would like to acquire.
 */
public abstract class Interests extends SimulationVector
{

    // ========================================================================

	public abstract Interests parse( IXMLElement xmlInterests );
    public abstract Interests copy();

	// ========================================================================

}
