//==========================================================================
//	This source code is part of the Agent Simulation Test Bed system which
//	was developed for simulating interaction among agents who are attempting 
//	to acquire information from each other and learn about each other. 
//
//	The system was created at North Carolina State Univeristy, 
//	Department of Computer Science between September and December 2001. 
//	It was implemented by Michael J. Suralik based on the specifications 
//	developed by Pinar Yolum and Bin Yu, who were conducting research under 
//   the guidance of Dr. Munindar Singh. 
//==========================================================================

package edu.ncsu.simulators.vectors;

import java.util.Enumeration;
import java.util.Vector;

/**
 * A Query SimulationVector represents a request for a particular body of 
 * knowledge.
 */
public final class Query extends SimulationVector
{
	//========================================================================			
	
	public Query()
	{	
	}

	//========================================================================			
	
	public Query copy()
	{
		return (Query)copy( new Query() );
	}
		
	//========================================================================			
	
	public static Query parse( String strQuery )
	{
		return (Query)parseFromString( strQuery, new Query() );
	}	
	
	//========================================================================				
}