
package edu.ncsu.simulators.agent;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;

/**
 * AgentModels is simply a collection of AgentModel objects
 */
public class AgentModels implements Cloneable
{
    private Hashtable hashAgentModels = null;
	
    //========================================================================

    public AgentModels()
    {
	hashAgentModels = new Hashtable();
    }

    public void addModel( AgentModel model) {

	if (model != null)
	    hashAgentModels.put( new Integer(model.getID()), model );
    }	

    /**
     * Returns true if id is in agentmodels
     *
     * @param id an <code>int</code> value
     * @return a <code>boolean</code> value
     */
    public boolean contains (int id) {

	return hashAgentModels.containsKey(new Integer(id));
    }
	
    //=======================================================================
    /**
     * Returns a deep copy of this AgentModels object.
     */
    public AgentModels copy()
    {		
	AgentModels copy = new AgentModels();
		
	Enumeration enumKeys = hashAgentModels.keys();
	Enumeration enumValues = hashAgentModels.elements();		
		
	while ( enumKeys.hasMoreElements() )
	    {
		copy.hashAgentModels.put( new Integer(((Integer)enumKeys.nextElement()).intValue()), ((AgentModel)enumValues.nextElement()).copy() );
	    }
		
	return copy;
    }
	
    //=======================================================================
    /**
     * Returns the model of the agent with the specified id.
     * Creates the model if it doesn't already exist.
     */
    public AgentModel getModel( Integer id )
    {
	AgentModel model = (AgentModel)hashAgentModels.get( id );
		
	if ( model == null )
	    {
		model = AgentModel.createDefaultAgentModel( id.intValue() );
		hashAgentModels.put( id, model );
	    }
			
	return model;
    }
	
    //=======================================================================
	
    public Iterator getModels()
    {
	return hashAgentModels.values().iterator();
    }
	
    //=======================================================================

    public Enumeration getEnumeration()
    {
	return hashAgentModels.elements();
    }
	
}
