package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;
/**
 * RunIndividualClustering.java
 *
 *
 * Created: Sun Dec  1 13:08:27 2002
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class RunIndividualClustering {
    public RunIndividualClustering (){
	
    }

    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        
        r.load(args[0]);
	Adjacency adjacencyTable = r.getAdjacency();

        VectorTable interestTable =r.getInterestTable(); 
        VectorTable expertiseTable=r.getExpertiseTable();
	
        Vector agents = r.getAgents();

        
        FileWriter outputFileWriter;

        DoubleVector interestSimilarity = new DoubleVector(); 
        DoubleVector expertiseSimilarity = new DoubleVector(); 
        DoubleVector plainClustering = new DoubleVector(); 

        int numberofAgents = adjacencyTable.size();
	//Find interest similarity clustering
	interestSimilarity = Metrics.interestSimilarityIndividuals(interestTable, 
								   adjacencyTable, agents);

	expertiseSimilarity= Metrics.interestSimilarityIndividuals(expertiseTable, 
								   adjacencyTable, agents);

	plainClustering = Metrics.plainClusteringIndividuals(adjacencyTable, agents);

	try {
	    outputFileWriter = new FileWriter("individualClustering.txt", false);	     
	    for (int j =0; j<numberofAgents; j++){
		outputFileWriter.write((new Double(interestSimilarity.elementAt(j))).toString());
		outputFileWriter.write("\t");
		outputFileWriter.write((new Double(expertiseSimilarity.elementAt(j))).toString());
		outputFileWriter.write("\t");
		outputFileWriter.write((new Double(plainClustering.elementAt(j))).toString());
		outputFileWriter.write("\n");
	    }
	    outputFileWriter.close();
	}


	catch( Exception e ) {
	    e.printStackTrace();
	}

    }

    
}// RunIndividualClustering
