package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;

/**
 * RunQuality.java
 *
 *
 * Created: Thu Apr 10 14:01:53 2003
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class RunQuality {
    public RunQuality (){
	
    }
    
    public static void main (String args[]) {
        GraphReader r = new GraphReader();
        
        r.load(args[0]);
                
        Adjacency adjacencyTable = r.getAdjacency();
        VectorTable interestTable =r.getInterestTable(); 
        VectorTable expertiseTable=r.getExpertiseTable();
	
        Vector agents = r.getAgents();

        FileWriter outputFileWriter;

        DoubleVector  quality = null;

        int numberofAgents = adjacencyTable.size();
	
	int[][] shortestPaths = new int[numberofAgents][numberofAgents];
        int[] d = new int[numberofAgents*2]; 
        int[] p = new int[numberofAgents*2];

        
        for (int j=0; j<numberofAgents; j++){
	    ShortestPath.belmannford(adjacencyTable, 
			((Integer)agents.get(j)).intValue(), d, p);
            for (int k=0; k<numberofAgents; k++)
	      shortestPaths[j][k] = d[k];
          
	    }

	//Find quality
	quality =  Metrics.listQuality(shortestPaths, agents, interestTable, expertiseTable, adjacencyTable);



	try {
	    outputFileWriter = new FileWriter(new String("quality.txt"), false);	     
	    for (int j =0; j<numberofAgents; j++)
		  outputFileWriter.write((new Double(quality.elementAt(j))).toString()+"\n");
	    outputFileWriter.close();
	}


	catch( Exception e ) {
	    e.printStackTrace();
	}

    }

}// RunQuality
