package edu.ncsu.simulators.analysis;

import java.util.*;
import java.io.*;

/**
 * RunSimilarities.java
 *
 *
 * Created: Tue Feb 11 10:46:02 2003
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class RunSimilarities {
    public RunSimilarities (){
	
    }

    public static void main (String args[]) {
	GraphReader r = new GraphReader();
        
	r.load(args[0]);
                
	Adjacency adjacencyTable = r.getAdjacency();
	VectorTable interestTable =r.getInterestTable(); 
	VectorTable expertiseTable=r.getExpertiseTable();
	
	Vector agents = r.getAgents();

	FileWriter outputFileWriter;

	double interestSimilarity = 0.0; 
	double clustering  = 0.0; 

	int numberofAgents = adjacencyTable.size();
	
	//Find interest similarity clustering
	interestSimilarity = Metrics.interestSimilarity(interestTable, adjacencyTable, agents);
	//Find expertise similarity clustering
	//expertiseSimilarity= Metrics.interestSimilarity(expertiseTable, adjacencyTable, agents);
      
	clustering = Metrics.plainClustering(adjacencyTable, agents);
      

	// Write everyting to their files in the log directory
	try {

	    outputFileWriter = new FileWriter( "interest-neighbor.txt", true);
	    outputFileWriter.write(new Double(interestSimilarity).toString());
	    outputFileWriter.write("\t");
	    outputFileWriter.write(new Double(clustering).toString());
	    outputFileWriter.write("\n");
	    outputFileWriter.close();
		
	} 

	catch( Exception e )
	    {
		e.printStackTrace();
	    }
    }
    
}// RunSimilarities
