
package edu.ncsu.simulators.classification;

import java.util.*;


public class HierarchicalCategory extends Category{

		private HashSet parents,children;
		private Category category;
		
		public HierarchicalCategory(Category c){
			category = c;
		}
		
		public HierarchicalCategory(String s) {
			super(s);
		}
		
		public HierarchicalCategory(Category c, Vector p, Vector ch){
			category = c;
			myGetParents().addAll(p);
			myGetChildren().addAll(ch);
		}
		
		public void setParents(Vector p){
			myGetParents().addAll(p);
		}
		
		public Iterator getParents(){
			if (parents != null)
				return parents.iterator();
			else 
				return null;
		}
		
		public void setChildren(Vector c){
			children.addAll(c);
		}
		
		public Iterator getChildren(){
			return myGetChildren().iterator();
		}
		
		public void addParent(HierarchicalCategory p){
			if ( !myGetParents().contains(p) ){
				myGetParents().add(p);
				p.addChild(this);
			}
		}
		
		public void addChild(HierarchicalCategory c){
			if ( !myGetChildren().contains(c) ){
				myGetChildren().add(c);
				c.addParent(this);
			}
		}
		
		public boolean isLeafCategory(){
			return (myGetChildren().size() == 0);
		}
		
		private HashSet myGetChildren(){
			if (children == null)
				children = new HashSet();
			return children;
		}
		
		private HashSet myGetParents(){
			if (parents == null)
				parents = new HashSet();
			return parents;
		}
		
		public String toString(){
			return new String("Category = "+name);
		}
			
}
