
package edu.ncsu.simulators.classification;

import java.util.*;

public class HierarchicalClassification {
	private HierarchicalCategory root;
	public HashSet categories;
	
	public HierarchicalClassification(HierarchicalCategory cat){
		HierarchicalCategory c = cat;

		while ( c.getParents() != null ) {
			try {
				c = (HierarchicalCategory)c.getParents().next();
			}catch(NoSuchElementException e){}
		}
		
		root = c;
	}
	
	public Iterator getIterator() {
		if (categories == null){
			categories = new HashSet();
			explore(this,root);
		}
		
		return categories.iterator();
	}
	
	private static void explore(HierarchicalClassification cl,
										HierarchicalCategory c) {
		if (c.isLeafCategory()) {
			cl.categories.add(c);
		} else {
			Iterator ite = c.getChildren();
			HierarchicalCategory cat;
			while (ite.hasNext()) {
				cat = (HierarchicalCategory)ite.next();
				explore(cl,cat);
				cl.categories.add(cat);
			}
		}
	}


	public static void main(String arg[]){
		HierarchicalCategory root,travel,air,car;
		
		root = new HierarchicalCategory("Commerce");
		travel = new HierarchicalCategory("Travel");
		air = new HierarchicalCategory("Air");
		car = new HierarchicalCategory("Car");
		
		travel.addParent(root);
		air.addParent(travel);
		car.addParent(travel);
		
		HierarchicalClassification classification = new HierarchicalClassification(root);		
		
		System.out.println(classification.getIterator());
	}
		
		
}
