
package edu.ncsu.simulators.concept;

import java.util.*;

public class ConceptLattice extends HashSet {
	private static Comparator comparator;
	
	public ConceptLattice(){
	}
	
	public ConceptLattice(HashSet concepts){
		addAll(concepts);
	}
	
	public boolean add(Object obj){
		if ( !(obj instanceof Concept) ){
			throw new ClassCastException("Cannot add non-concepts to concept lattice");
		}
		return add(obj);
	}

	public void sort(){
		Collections.sort(new ArrayList(this), getMyConceptComparator());
	}
	
	private Comparator getMyConceptComparator(){
		if (comparator == null)
			comparator = new ConceptComparator();
		return comparator;
	}
}

