package edu.ncsu.simulators.policies;

import edu.ncsu.simulators.Constants;

import edu.ncsu.simulators.agent.AgentModel;
import edu.ncsu.simulators.agent.AgentModels;
import edu.ncsu.simulators.agent.Neighbors;
import edu.ncsu.simulators.policies.Heuristics;
import edu.ncsu.simulators.util.RandomIterator;
import edu.ncsu.simulators.vectors.Query;
import edu.ncsu.simulators.vectors.Expertise;
import edu.ncsu.simulators.vectors.DomainExpertise;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

/**
 * AskingPolicy_Lattice
 * 
 * 
 * Created: Mon Jun  3 14:22:04 2002
 * 
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version 1
 */
 

public class AskingPolicy_Lattice implements AskingPolicy{
    
    public AskingPolicy_Lattice (){
    }
    //Returns all neighbors
    public Iterator getNeighborsToAsk( Query query, Neighbors neighbors, AgentModels agentModels ){
	//	return getNeighborsWithSufficientSimilarity( query, neighbors, agentModels, 
	//		  Constants.SIMILARITY_THRESHOLD_FOR_ASKING_NEIGHBOR );
	return neighbors.iterator();
    }

    private Iterator getNeighborsWithSufficientSimilarity( Query query, Neighbors neighbors, AgentModels agentModels, double similarityThreshold )
    {	
	Iterator iteratorKnowledgeableNeighbors = null;
		
	Iterator iteratorNeighbors = neighbors.iterator();
	Vector vecKnowledgeableNeighbors = new Vector();

	while( iteratorNeighbors.hasNext() )
	    {
		Integer neighborID = (Integer)iteratorNeighbors.next();		
		AgentModel neighborModel = agentModels.getModel( neighborID );			
		DomainExpertise neighborExpertise = (DomainExpertise)neighborModel.getExpertise();
		
		if (((Double)neighborExpertise.elementAt(((Double)query.elementAt(0)).intValue())).doubleValue() 
		    >= similarityThreshold )
			vecKnowledgeableNeighbors.addElement( neighborID );

	    }
		
	// Create an Iterator that will iterate over the knowledgeable neighbors in some random order.
	iteratorKnowledgeableNeighbors = RandomIterator.getRandomIterator( vecKnowledgeableNeighbors );
		
	return iteratorKnowledgeableNeighbors;
    }	

}// AskingPolicy_Lattice
