package edu.ncsu.simulators.policies;

import edu.ncsu.simulators.Constants;
import edu.ncsu.simulators.agent.AgentModel;
import edu.ncsu.simulators.agent.AgentModels;
import edu.ncsu.simulators.dialogs.ReferralChain;
import edu.ncsu.simulators.dialogs.ReferralChainDAG;

import edu.ncsu.simulators.util.ErrorHandler;
import edu.ncsu.simulators.util.Heuristics;
import edu.ncsu.simulators.vectors.Answer;
import edu.ncsu.simulators.vectors.Expertise;
import edu.ncsu.simulators.vectors.DomainExpertise;
import edu.ncsu.simulators.vectors.Interests;
import edu.ncsu.simulators.vectors.Query;

import java.io.FileWriter;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;



/**
 * 
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 */

public class LearningPolicy_DNS extends LearningPolicy_Standard implements LearningPolicy

{

    private static final int BAD_ANSWER = 1;
    private static final int GOOD_ANSWER = 2;
    private static final int NO_ANSWER = 3;



    public LearningPolicy_DNS(){

    }


    public void learnFromQuestion( AgentModel modelQuestioner, Query query ){

    }
    
    public void setFileWriter( FileWriter fw ){
    }

	
    public void learnFromResponses( ReferralChain referralChain, AgentModels agentModels, Expertise expertiseOfAskingAgent  ){

	Answer bestAnswer = null;
	Query query = referralChain.getQuery();
	Hashtable hashAnswers = referralChain.getAnswers();

	Enumeration enumAgentIDs = hashAnswers.keys();
	Enumeration enumAnswers = hashAnswers.elements();


	while ( enumAgentIDs.hasMoreElements() ){
	    Integer answeringAgentID = (Integer)enumAgentIDs.nextElement();
	    Answer answer = (Answer)enumAnswers.nextElement();         
	    AgentModel modelAnsweringAgent = agentModels.getModel( answeringAgentID );

	    int grade = evaluateAnswer( query, answer );

	    updateExpertise( modelAnsweringAgent, grade, answer );

	    int generationsRemoved = 0;

	    Enumeration enumGenerations = referralChain.getAncestorsByGeneration( answeringAgentID.intValue() );

	    while ( enumGenerations.hasMoreElements() )
		{
		    generationsRemoved++;
		    Enumeration enumAncestors = (Enumeration)enumGenerations.nextElement();
		    while( enumAncestors.hasMoreElements() )
			{
			    Integer ancestorID = (Integer)enumAncestors.nextElement();
			    AgentModel modelAncestor = agentModels.getModel( ancestorID );

			    updateSociability( modelAncestor, query, grade, generationsRemoved );
			}
		}
	}

    }
}

