package edu.ncsu.simulators.policies;

import edu.ncsu.simulators.vectors.Query;
import edu.ncsu.simulators.vectors.Expertise;
import edu.ncsu.simulators.vectors.Interests;
import edu.ncsu.simulators.Constants;
import java.util.*;
/**
 * QueryGenerationPolicy_Random.java
 *
 *
 * Created: Tue Aug 20 18:20:47 2002
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class QueryGenerationPolicy_Random implements QueryGenerationPolicy{
    public QueryGenerationPolicy_Random (){
	
    }
    /**
     * Describe <code>generateDistributionQuery</code> method here.
     *
     * @param expertise an <code>Expertise</code> value
     * @param interests an <code>Interests</code> value
     * @param random a <code>Random</code> value
     * @return a <code>Query</code> value
     */
    public Query generateQuery(Expertise expertise, Interests interests, Random random){
	
	double role = random.nextDouble();
	Query currentQuery = new Query();

	int roleNumber = -1;
	if (role<= 0.045) 
	    roleNumber = 0; 
	else if ( role <= 0.136) 
	    roleNumber = 1; 
	else if ( role <= 0.226) 
	    roleNumber = 2; 
	else if ( role <= 0.406) 
	    roleNumber = 3; 
	else if ( role <= 0.586) 
	    roleNumber = 4; 
	else if ( role <= 0.766) 
	    roleNumber = 5; 
	else if ( role <= 0.856) //0.856 
	    roleNumber = 6; 
	else if ( role <= 0.946) //0.946 
	    roleNumber = 7;
	else roleNumber = 8;
	
	currentQuery = new Query();
	for (int i=0; i<interests.size(); i++) {
		currentQuery.add(new Double(0));	    
	} // end of for ()
	currentQuery.remove(roleNumber);
	currentQuery.add(roleNumber, new Double(1));
	System.out.println(" current query is " + currentQuery.toTruncatedString());

	return currentQuery;
    }
}// QueryGenerationPolicy_Random
