package edu.ncsu.simulators.policies;


import edu.ncsu.simulators.Constants;
import edu.ncsu.simulators.agent.AgentModel;
import edu.ncsu.simulators.agent.AgentModels;
import edu.ncsu.simulators.agent.Neighbors;
import edu.ncsu.simulators.policies.Heuristics;
import edu.ncsu.simulators.vectors.Query;

import java.util.Hashtable;
import java.util.Iterator;

/**
 * ReferringPolicy_Lattice.java
 *
 *
 * Created: Sun Jun  9 15:35:45 2002
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version 1.0
 */

public class ReferringPolicy_Lattice implements ReferringPolicy{
    public ReferringPolicy_Lattice (){
	
    }

    public Iterator getNeighborsToReferTo(AgentModel modelQuestioner, Query query, Neighbors neighbors, AgentModels agentModels, int myId) {
	return getNeighborsWithSufficientSimilarity(query, neighbors, agentModels, Constants.SIMILARITY_THRESHOLD_FOR_REFERING_QUESTIONER_TO_NEIGHBOR );
    }	
	

    private Iterator getNeighborsWithSufficientSimilarity( Query query, Neighbors neighbors, AgentModels agentModels, double similarityThreshold) {

	Hashtable hashKnowledgeableNeighbors = new Hashtable();
	Iterator iteratorNeighbors = neighbors.iterator();
	int providerId = ((Double)query.elementAt(0)).intValue();

	while(iteratorNeighbors.hasNext()) {

	    Integer neighborID = (Integer)iteratorNeighbors.next();		
	    AgentModel neighborModel = agentModels.getModel( neighborID );			

	    if (((Double)neighborModel.getExpertise().elementAt(providerId)).doubleValue() > similarityThreshold) {
		hashKnowledgeableNeighbors.put( neighborID, neighborID );
		//System.out.println("refer " + neighborID + " for " + providerId);
	    }
	    
	    
	}

	return hashKnowledgeableNeighbors.values().iterator();

    }
	
}// ReferringPolicy_Lattice
