//==========================================================================
//	This source code is part of the Agent Simulation Test Bed system which
//	was developed for simulating interaction among agents who are attempting 
//	to acquire information from each other and learn about each other. 
//
//	The system was created at North Carolina State Univeristy, 
//	Department of Computer Science between September and December 2001. 
//	It was implemented by Michael J. Suralik based on the specifications 
//	developed by Pinar Yolum and Bin Yu, who were conducting research under 
//   the guidance of Dr. Munindar Singh. 
//==========================================================================

package edu.ncsu.simulators.vectors;

import java.lang.*;
import java.io.*;
import java.util.*;

import java.io.StreamTokenizer;
import java.io.StringReader;
import java.util.Enumeration;
import java.util.Vector;

/**
 * An Answer represents an offering of a body of knowledge in response to
 * a query.
 */
public class Answer extends SimulationVector
{	
	//========================================================================			
	
	public Answer()
	{
	}	
	
	//========================================================================			
	
	public Answer copy()
	{
		return (Answer)copy( new Answer() );
	}
	
	//========================================================================			
	
	public static Answer parse( String strAnswer )
	{
		return (Answer)parseFromString( strAnswer, new Answer() );
	}	
	
	//========================================================================			
}