package edu.ncsu.simulators.vectors;

import net.n3.nanoxml.IXMLElement;
/**
 * ScalarSociability.java
 *
 *
 * Created: Tue Jan 21 10:52:21 2003
 *
 * @author <a href="mailto:pyolum@eos.ncsu.edu">Pinar Yolum</a>
 * @version
 */

public class ScalarSociability extends Sociability {

    double sociability = 0.0;

    public ScalarSociability (double d){
	this.sociability = d;
    }

    public ScalarSociability (){
	this.sociability = 0.0;
    }

    /**
     * Not meant to be used.
     *
     * @param xmlSociability an <code>IXMLElement</code> value
     * @return a <code>Sociability</code> value
     */
    public  Sociability parse( IXMLElement xmlSociability ){

	return (Sociability)parseFromXML( xmlSociability, new ScalarSociability() );
    }

    public  Sociability copy(){
	return (Sociability)copy( new ScalarSociability(this.sociability) );
    }

    /**
     * Get the value of sociability.
     * @return value of sociability.
     */
    public double getSociability() {
	return sociability;
    }
    
    /**
     * Set the value of sociability.
     * @param v  Value to assign to sociability.
     */
    public void setSociability(double  v) {
	this.sociability = v;
    }
    
}// ScalarSociability
